--- a/src/org/armedbear/lisp/Autoload.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Autoload.java	Tue Jan 26 12:34:38 2010 +0100
@@ -663,6 +663,7 @@
         autoload(PACKAGE_SYS, "simple-list-remove-duplicates", "simple_list_remove_duplicates");
         autoload(PACKAGE_SYS, "single-float-bits", "FloatFunctions", true);
         autoload(PACKAGE_SYS, "std-allocate-instance", "StandardObjectFunctions", true);
+        autoload(PACKAGE_SYS, "unzip", "unzip", true);
         autoload(PACKAGE_SYS, "zip", "zip", true);
 
         autoload(PACKAGE_SYS, "proxy-preloaded-function",
diff -r f77229934d59 src/org/armedbear/lisp/AutoloadedFunctionProxy.java
--- a/src/org/armedbear/lisp/AutoloadedFunctionProxy.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/AutoloadedFunctionProxy.java	Tue Jan 26 12:34:38 2010 +0100
@@ -52,7 +52,7 @@
             AUTOLOADING_CACHE, // allow loading local preloaded functions
             Load._FASL_ANONYMOUS_PACKAGE_, // package for uninterned symbols
             Symbol._PACKAGE_,              // current package
-            Symbol.LOAD_TRUENAME           // LOAD-TIME-VALUE depends on this
+            Symbol.LOAD_TRUENAME          // LOAD-TIME-VALUE depends on this
         };
 
     final private Symbol symbol;
@@ -304,7 +304,8 @@
       Hashtable cache
           = (Hashtable)AUTOLOADING_CACHE.symbolValue(thread).javaInstance();
 
-      byte[] bytes = readFunctionBytes(namestring);
+      Pathname pathname = new Pathname(namestring);
+      byte[] bytes = readFunctionBytes(pathname);
       cache.put(namestring, bytes);
 
       return T;
diff -r f77229934d59 src/org/armedbear/lisp/Interpreter.java
--- a/src/org/armedbear/lisp/Interpreter.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Interpreter.java	Tue Jan 26 12:34:38 2010 +0100
@@ -285,8 +285,8 @@
                     if (i + 1 < args.length) {
                         if (arg.equals("--load"))
                             Load.load(new Pathname(args[i + 1]),
-                                      args[i + 1],
                                       false, false, true);
+
                         else
                             Load.loadSystemFile(args[i + 1]);
                         ++i;
diff -r f77229934d59 src/org/armedbear/lisp/Lisp.java
--- a/src/org/armedbear/lisp/Lisp.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Lisp.java	Tue Jan 26 12:34:38 2010 +0100
@@ -1201,134 +1201,54 @@
                                              LispThread.currentThread());
   }
 
+    @Deprecated
   public static final LispObject loadCompiledFunction(final String namestring)
-
   {
-      byte[] bytes = readFunctionBytes(namestring);
+      Pathname name = new Pathname(namestring);
+      byte[] bytes = readFunctionBytes(name);
       if (bytes != null)
         return loadClassBytes(bytes);
 
       return null;
   }
 
-  public static final byte[] readFunctionBytes(final String namestring)
-  {
+  public static final byte[] readFunctionBytes(final Pathname name) {
     final LispThread thread = LispThread.currentThread();
-    final boolean absolute = Utilities.isFilenameAbsolute(namestring);
-    LispObject device = NIL;
-    final Pathname defaultPathname;
-    if (absolute)
-      {
-        defaultPathname =
-          coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue(thread));
-      }
-    else
-      {
-        LispObject loadTruename = Symbol.LOAD_TRUENAME.symbolValue(thread);
-        if (loadTruename instanceof Pathname)
-          {
-            defaultPathname = (Pathname) loadTruename;
-            // We're loading a file.
-            device = ((Pathname)loadTruename).getDevice();
-          }
-        else
-          {
-            defaultPathname =
-              coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue(thread));
-          }
-      }
-    if (device instanceof Pathname) { //Loading from a jar
-	URL url = null;
-	String jar = ((Pathname)device).getNamestring();
-	if(jar.startsWith("jar:")) {
-	    try {
-		url = new URL(jar + "!/" + namestring);
-	    } catch (MalformedURLException ex) {
-		Debug.trace(ex);
-	    }
-	} else {
-	    url = Lisp.class.getResource(namestring);
-	}
-        if (url != null) {
-            try {
-		InputStream input = null;		
-		java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
-		try {
-		    input = url.openStream();               
-		    byte[] bytes = new byte[4096];
-		    int n = 0;
-		    while (n >= 0) {
-			n = input.read(bytes, 0, 4096);
-			if(n >= 0) {
-			    baos.write(bytes, 0, n);
-			}
-		    }
-		    bytes = baos.toByteArray();
-		    return bytes;
-		} finally {
-		    baos.close();
-		    if(input != null) {
-			input.close();
-		    }
-		}
-	    } catch (IOException e) {
-                Debug.trace(e);
-	    }
-	}
-        error(new LispError("Unable to load " + namestring));
-        return null; // not reached
+    Pathname load = null;
+    LispObject truenameFasl = Symbol.LOAD_TRUENAME_FASL.symbolValue(thread);
+    LispObject truename = Symbol.LOAD_TRUENAME.symbolValue(thread);
+    Pathname fasl = null;
+    if (truenameFasl instanceof Pathname) {
+        load = Pathname.mergePathnames(name, (Pathname)truenameFasl, Keyword.NEWEST);
+    } else if (truename instanceof Pathname) {
+        load = Pathname.mergePathnames(name, (Pathname) truename, Keyword.NEWEST);
+    } else {
+        load = name;
     }
-    Pathname pathname = new Pathname(namestring);
-    final File file = Utilities.getFile(pathname, defaultPathname);
-    if (file != null && file.isFile())
-      {
-        // The .cls file exists.
-        try
-          {
-            byte[] bytes = readFunctionBytes(new FileInputStream(file),
-                                             (int) file.length());
-            // FIXME close stream!
-            if (bytes != null)
-              return bytes;
-          }
-        catch (FileNotFoundException fnf) {
-            error(new LispError("Unable to load " + pathname.writeToString()
-                                + ": " + fnf.getMessage()));
-            return null; // not reached
+    InputStream input = load.getInputStream();
+    if (input == null) {
+        Debug.trace("Pathname: " + name);
+        Debug.trace("LOAD_TRUENAME_FASL: " + truenameFasl);
+        Debug.trace("LOAD_TRUENAME: " + truename);
+        Debug.assertTrue(input != null);
+    }
+    byte[] bytes = new byte[4096];
+    int n = 0;
+    java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
+    try {
+        while (n >= 0) {
+            n = input.read(bytes, 0, 4096);
+            if(n >= 0) {
+                baos.write(bytes, 0, n);
+            }
         }
-        return null; // not reached
-      }
-    try
-      {
-        LispObject loadTruename = Symbol.LOAD_TRUENAME.symbolValue(thread);
-        String zipFileName = ((Pathname)loadTruename).getNamestring();
-        ZipFile zipFile = ZipCache.getZip(zipFileName);
-        try
-          {
-            ZipEntry entry = zipFile.getEntry(namestring);
-            if (entry != null)
-              {
-                byte[] bytes = readFunctionBytes(zipFile.getInputStream(entry),
-                                                 (int) entry.getSize());
-                if (bytes != null)
-                  return bytes;
-                Debug.trace("Unable to load " + namestring);
-                error(new LispError("Unable to load " + namestring));
-                return null; // not reached
-              }
-          }
-        finally
-          {
-            ZipCache.removeZip(zipFile.getName());
-          }
-      }
-    catch (IOException t)
-      {
-        Debug.trace(t);
-      }
-    error(new FileError("File not found: " + namestring,
-                        new Pathname(namestring)));
-    return null; // not reached
+    } catch (IOException e) {
+        Debug.trace("Failed to read bytes from "
+                    + "'" + name.getNamestring() + "'");
+        return null;
+    }
+    bytes = baos.toByteArray();
+    return bytes;
   }
 
     public static final Function makeCompiledFunctionFromClass(Class<?> c) {
@@ -2395,6 +2315,7 @@
     Symbol.LOAD_PRINT.initializeSpecial(NIL);
     Symbol.LOAD_PATHNAME.initializeSpecial(NIL);
     Symbol.LOAD_TRUENAME.initializeSpecial(NIL);
+    Symbol.LOAD_TRUENAME_FASL.initializeSpecial(NIL);
     Symbol.COMPILE_VERBOSE.initializeSpecial(T);
     Symbol.COMPILE_PRINT.initializeSpecial(T);
     Symbol._COMPILE_FILE_PATHNAME_.initializeSpecial(NIL);
@@ -2784,3 +2705,6 @@
   }
 
 }
+// Local Variables:
+// c-basic-offset: 4
+// End:
